---

include:
  - local: /templates/.gitlab-ci-aws-cfn.yml
  - local: /cfn-build/.gitlab-ci.yml
  - local: /cfn-test/.gitlab-ci.yml
  # - local: /cfn-deploy/.gitlab-ci.yml
  - project: jhctech-oss/code-quality/Git
    file: /templates/.gitlab-ci-git.yml
    ref: v0.4
  - project: jhctech-oss/code-quality/code-inspector
    file: /templates/.gitlab-ci-code-inspector.yml
    ref: v0.0.1
  - local: /templates/.gitlab-ci-env-vars.yml

image: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"

.docker:
  image: docker:19.03-git
  services:
    - docker:19.03-dind
  variables:
    DOCKER_DRIVER: overlay2
  before_script:
    - echo ${CI_JOB_TOKEN} | docker login --password-stdin -u $CI_REGISTRY_USER $CI_REGISTRY

# run otherwise conditional jobs always to ensure they are tested before released
.rules_cloudformation_static:
  rules:
    - when: always

variables:
  BUILD_IMAGE_NAME: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA"
  CFN_BASE_TEMPLATE_NAME: S3Bucket.yml
  CFN_TEMPLATE_PATH: samples

  CODE_INSPECTOR_ALLOW_VIOLATIONS: 'true' ## accept code-inspector violations for now

stages:
  - pre-build
  - build
  - unit test
  - integration test
  - qa
  - cleanup
  - deliver
  - deploy

.cleanup_aws:
  stage: cleanup
  when: always # run cleanups job always regardless of previous job failures

before_script:
  # make all bash scripts executable
  - find . -type f -iname "*.sh" -exec chmod a+x {} \;

.pre_build:image:
  extends: .docker
  stage: pre-build
  script:
    - docker build -t "$BUILD_IMAGE_NAME" .
    - docker push "$BUILD_IMAGE_NAME"

pre-build:image:
  extends: .pre_build:image

pre-build:mr:image:
  extends: .pre_build:image
  only:
    - merge_requests

deploy:image:
  extends: .docker
  stage: deploy
  script:
    - echo ${CI_JOB_TOKEN} | docker login --password-stdin -u $CI_REGISTRY_USER $CI_REGISTRY
    - echo "Using tag $CI_COMMIT_TAG for image"
    - docker pull "$BUILD_IMAGE_NAME"
    - docker tag "$BUILD_IMAGE_NAME" "$CI_REGISTRY_IMAGE:latest"
    - docker tag "$BUILD_IMAGE_NAME" "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG"
    - docker push "$CI_REGISTRY_IMAGE:latest"
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG"
  only:
    - tags
